#!/bin/ksh

[ $AAPP_PREFIX ] || { echo "AAPP_PREFIX is not defined"; exit; }
[ -d "$AAPP_PREFIX" ] || { echo "AAPP_PREFIX is not a directory"; exit; }

bufr_dump -V || { echo "Please add the ecCodes 'bin' directory to your path";  exit 1; }

file_identifier=$1     #optional - first part of file name e.g. iasi

bufr_dir_bufrdc=$PWD/bufrdc_bufr
bufr_dir_eccodes=$PWD/eccodes_bufr

cd $bufr_dir_bufrdc
for file in ${file_identifier}*.bufr; do
  if [[ $file = hirsl1d* ]] && [ ! "$ECCODES_DEFINITION_PATH" ]; then
    echo 'NOT running the HIRS 1d decoding'
    echo 'To run it, you would need to define environment variable ECCODES_DEFINITION_PATH'
    echo 'e.g. export ECCODES_DEFINITION_PATH=$DIR_ECCODES/share/eccodes/definitions:$AAPP_PREFIX/AAPP/data/tools_eccodes/definitions'
    echo 'where $DIR_ECCODES is the ecCodes installation directory'
    echo
  else
    echo "bufr_dump $file"
    bufr_dump $file >$file.txt
  fi
done

cd $bufr_dir_eccodes
for file in ${file_identifier}*.bufr; do
  if [[ $file = hirsl1d* ]] && [ ! "$ECCODES_DEFINITION_PATH" ]; then
    echo 'NOT running the HIRS 1d decoding'
    echo 'To run it, you would need to define environment variable ECCODES_DEFINITION_PATH'
    echo 'e.g. export ECCODES_DEFINITION_PATH=$DIR_ECCODES/share/eccodes/definitions:$AAPP_PREFIX/AAPP/data/tools_eccodes/definitions'
    echo 'where $DIR_ECCODES is the ecCodes installation directory'
    echo
  else
    echo "bufr_dump $file"
    bufr_dump $file >$file.txt
  fi
done

for file in ${file_identifier}*.txt; do
  if [ "$file" ]; then
    echo "diff $file $bufr_dir_bufrdc"
    diff $file $bufr_dir_bufrdc >${file}.diff
  fi
done
echo "see difference files in $PWD"
